<template>
  <div>

    <div v-if="beegardens.toString().length < 3">
      <h1>Najpierw dodaj pasiekę!</h1>

      <div>
        <button class="btn btn-info"  v-on:click="addBeegarden()">Dodaj pasiekę</button>
      </div>


    </div>

    <div v-if="beegardens.toString().length > 3">

      <h2> Dodaj ul: </h2>
      <form
          v-on:submit.prevent="submitForm"
      >

        <div>
          <label for="beegardenId">Wybierz pasiekę do której chcesz dodać ul:</label>
          <select id="beegardenId" v-model="form.beegardenId" required>
            <option disabled value="">Wybierz odpowiednią:</option>
            <option v-for="item in beegardens" v-bind:key="item.id" :value=item.id>{{ item.beegardenName }}</option>
          </select>
        </div>

        <div class="form-group">
          <label for="beegardenName">Nazwa:</label>
          <input type="text" class="form-control" id="beegardenName" placeholder="Nazwa Twojego ula"
                 v-model="form.beehiveName" required maxlength="30">
        </div>

        <div class="form-group">
          <label>Rodzaj ula:</label><br/>

          <div v-if="wasSubmitted && !form.type">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_wielkopolski" value="wielkopolski"
                   v-model="form.type">
            <label class="form-check-label" for="type_wielkopolski">wielkopolski</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_dadanta" value="dadanta"
                   v-model="form.type">
            <label class="form-check-label" for="type_dadanta">dadanta</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_warszawski_p"
                   value="warszawski poszerzony"
                   v-model="form.type">
            <label class="form-check-label" for="type_warszawski_p">warszawski poszerzony</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_warszawski_z" value="warszawski zwykły"
                   v-model="form.type">
            <label class="form-check-label" for="type_warszawski_z">warszawski zwykły</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_langstroth" value="langstroth"
                   v-model="form.type">
            <label class="form-check-label" for="type_langstroth">langstroth</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_ostrowskiej" value="ostrowskiej"
                   v-model="form.type">
            <label class="form-check-label" for="type_ostrowskiej">ostrowskiej</label>
          </div>
          <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="type" id="type_apipol" value="apipol"
                   v-model="form.type">
            <label class="form-check-label" for="type_apipol">apipol</label>
          </div>
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.dateOfCreation">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="dateOfCreation">Data założenia ula:</label>
          <vue-englishdatepicker id="dateOfCreation" v-model="form.dateOfCreation"/>
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.framesAmount">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="framesAmount">Ilość ramek:</label>
          <br />

          <VueSimpleRangeSlider
              id="framesAmount"
              style="width: 500px"
              :min="1"
              :max="100"
              :logarithmic="false"
              v-model="form.framesAmount"
          />
        </div>


        <div class="form-group">
          <div v-if="wasSubmitted && !form.trunksAmount">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="trunksAmount">Ilość korpusów:</label>
          <br />
          <VueSimpleRangeSlider
              id="trunksAmount"
              style="width: 500px"
              :min="1"
              :max="10"
              :logarithmic="false"
              v-model="form.trunksAmount"
          />
        </div>

        <div class="form-group">
          <label for="bottom">Rodzaj dennicy:</label>


          <select id="bottom" v-model="form.bottom" required>
            <option disabled value="">Wybierz odpowiednią:</option>
            <option>higieniczna</option>
            <option>z poławiaczem pyłku</option>
            <option>niska ocieplana</option>
          </select>
        </div>

        <div class="form-group">
          <label for="feeder">Podkarmiaczka?</label>
          <input type="checkbox" unchecked-value="false" id="feeder" v-model="form.feeder">
        </div>

        <div class="form-group">
          <label for="poolenTrapper">Poławiacz pyłku?</label>
          <input type="checkbox" unchecked-value="false" id="poolenTrapper" v-model="form.poolenTrapper" value="false">
        </div>

        <div class="form-group">
          <label for="propolisSinker">Poławiacz propolisu?</label>
          <input type="checkbox" unchecked-value="false" id="propolisSinker" v-model="form.propolisSinker"
                 value="false">
        </div>

        <div class="form-group">
          <label for="queenCage">Izolator matek?</label>
          <input type="checkbox" unchecked-value="false" id="queenCage" v-model="form.queenCage" value="false">
        </div>

        <div class="form-group">
          <label for="barrier">Krata odgrodowa?</label>
          <input type="checkbox" unchecked-value="false" id="barrier" v-model="form.barrier" value="false">
        </div>

        <div class="form-group">
          <label for="isolator">Izolator?</label>
          <input type="checkbox" unchecked-value="false" id="isolator" v-model="form.isolator" value="false">
        </div>

        <div class="form-group">
          <label for="heater">Podgrzewany?</label>
          <input type="checkbox" unchecked-value="false" id="heater" v-model="form.heater" value="false">
        </div>

        <div class="form-group">
          <label for="queenCell">Czerw?</label>
          <input type="checkbox" unchecked-value="false" id="queenCell" v-model="form.queenCell" value="false">
        </div>

        <div class="form-group">
          <label for="swarmMood">Nastrój rojowy?</label>
          <input type="checkbox" unchecked-value="false" id="swarmMood" v-model="form.swarmMood" value="false">
        </div>

        <div class="form-group">
          <label for="lackOfFood">Brak pokarmu?</label>
          <input type="checkbox" unchecked-value="false" id="lackOfFood" v-model="form.lackOfFood" value="false">
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.inletWidth">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="inletWidth">Szerokość wylotka:</label>

          <br />

          <VueSimpleRangeSlider
              id="inletWidth"
              style="width: 500px"
              :min="1"
              :max="50"
              :logarithmic="false"
              v-model="form.inletWidth"
          />
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.workFramesAmount">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="workFramesAmount">Ilość ramek pracy:</label>

          <br />

          <VueSimpleRangeSlider
              id="workFramesAmount"
              style="width: 500px"
              :min="1"
              :max="40"
              :logarithmic="false"
              v-model="form.workFramesAmount"
          />
        </div>

        <div class="form-group">
          <label for="force">Siła rodziny:</label>
          <select id="force" v-model="form.force" required>
            <option disabled value="">Siła:</option>
            <option>Słaba</option>
            <option>Średnia</option>
            <option>Mocna</option>
          </select>
        </div>

        <div class="form-group">
          <label for="temperament">Temperament rodziny:</label>
          <select id="temperament" v-model="form.temperament" required>
            <option disabled value="">Siła:</option>
            <option>Potulna</option>
            <option>Średnia</option>
            <option>Agresywna</option>
          </select>
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.grubs">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="grubs">Ilość czerwiu:</label>

          <br />

          <VueSimpleRangeSlider
              id="grubs"
              style="width: 500px"
              :min="1"
              :max="10"
              :logarithmic="false"
              v-model="form.grubs"
          />
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.propolis">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="propolis">Ilość pyłku:</label>

          <br />

          <VueSimpleRangeSlider
              id="propolis"
              style="width: 500px"
              :min="1"
              :max="40"
              :logarithmic="false"
              v-model="form.propolis"
          />
        </div>

        <div class="form-group">

          <div v-if="wasSubmitted && !form.honey">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="honey">Ilość miodu:</label>

          <br />

          <VueSimpleRangeSlider
              id="honey"
              style="width: 500px"
              :min="1"
              :max="40"
              :logarithmic="false"
              v-model="form.honey"
          />
        </div>

        <div class="form-group">
          <button class="btn btn-primary">Dodaj ul</button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import VueEnglishdatepicker from 'vue-englishdatepicker';
import VueSimpleRangeSlider from 'vue-simple-range-slider';
import beehiveobject from "@/models/beehiveobject";
import 'vue-simple-range-slider/dist/vueSimpleRangeSlider.css'
import BeegardenService from '../../services/beegarden.service'
import BeehiveService from '../../services/beehive.service'


export default {
  name: 'AddBeehive',
  components: {
    VueEnglishdatepicker,
    VueSimpleRangeSlider
  },
  data() {
    return {
      form: new beehiveobject(false, '', '', '', '',
          '', false, '', '', false, '', '', false,
          false, false, '', false, false, false,
          false, '', '', '', ''),

      response: '',
      wasSubmitted: false,
      beegardens: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      BeegardenService.getAllBeegardensFromUser(this.currentUser.id).then(
          response => {
            this.beegardens = response.data;
          },
          error => {
            this.beegardens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      )
    }
  },
  methods: {

    submitForm() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        this.wasSubmitted = true

        if (this.checkObject()) {

          BeehiveService.addNewBeehive(this.form).then(
              response => {
                this.response = response.data;
                alert('Ul dodany poprawnie! :)')
                this.$router.push('/boardbeehives');
              },
              error => {
                this.response =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          )
        } else {
          alert('Uzupełnij brakujące dane!')
        }
      }
    },

    checkObject() {
      if (
          !this.form.beegardenId ||
          !this.form.beehiveName ||
          !this.form.bottom ||
          !this.form.dateOfCreation ||
          !this.form.force ||
          !this.form.framesAmount ||
          !this.form.grubs ||
          !this.form.honey ||
          !this.form.inletWidth ||
          !this.form.propolis ||
          !this.form.temperament ||
          !this.form.trunksAmount ||
          !this.form.type ||
          !this.form.workFramesAmount
      )
        return false
      else
        return true
    },

    addBeegarden() {
      this.$router.push('/addbeegarden');
    },
  }
};

</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>